scala.collection.mutable

# FlatHashTable

###
Related Doc: package mutable

#### trait FlatHashTable[A] extends HashUtils[A]

An implementation class backing a `HashSet`.

This trait is used internally. It can be mixed in with various collections relying on hash table as an implementation.

Source
  FlatHashTable.scala

Linear Supertypes
HashUtils[A], AnyRef, Any
Known Subclasses
HashSet, ParFlatHashTable, ParHashSet
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. FlatHashTable
2. HashUtils
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from FlatHashTable[A] to any2stringadd[FlatHashTable[A]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (FlatHashTable[A], B)

   Implicit information
     This member is added by an implicit conversion from FlatHashTable[A] to ArrowAssoc[FlatHashTable[A]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def addElem(elem: A): Boolean

   Add elem if not yet in table.

   Add elem if not yet in table.

   returns

     Returns `true` if a new elem was added, `false` otherwise.

   Attributes
     protected

7. #### def addEntry(newEntry: AnyRef): Boolean

   Add an entry (an elem converted to an entry via elemToEntry) if not yet in table.

   Add an entry (an elem converted to an entry via elemToEntry) if not yet in table.

   returns

     Returns `true` if a new elem was added, `false` otherwise.

   Attributes
     protected

8. #### def alwaysInitSizeMap: Boolean

   Attributes
     protected

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### def calcSizeMapSize(tableLength: Int): Int

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

11. #### def capacity(expectedSize: Int): Int

    Attributes
      protected

12. #### def clearTable(): Unit

    Attributes
      protected

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

14. #### def containsElem(elem: A): Boolean

    Checks whether an element is contained in the hash table.

    Checks whether an element is contained in the hash table.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

15. #### final def elemToEntry(elem: A): AnyRef

    Elems have type A, but we store AnyRef in the table.

    Elems have type A, but we store AnyRef in the table. Plus we need to deal with null elems, which need to be stored as NullSentinel

    Attributes
      protected
    Definition Classes
      HashUtils

16. #### def ensuring(cond: (FlatHashTable[A]) ⇒ Boolean, msg: ⇒ Any): FlatHashTable[A]

    Implicit information
      This member is added by an implicit conversion from FlatHashTable[A] to Ensuring[FlatHashTable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: (FlatHashTable[A]) ⇒ Boolean): FlatHashTable[A]

    Implicit information
      This member is added by an implicit conversion from FlatHashTable[A] to Ensuring[FlatHashTable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean, msg: ⇒ Any): FlatHashTable[A]

    Implicit information
      This member is added by an implicit conversion from FlatHashTable[A] to Ensuring[FlatHashTable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean): FlatHashTable[A]

    Implicit information
      This member is added by an implicit conversion from FlatHashTable[A] to Ensuring[FlatHashTable[A]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### final def entryToElem(entry: AnyRef): A

    Does the inverse translation of elemToEntry

    Does the inverse translation of elemToEntry

    Attributes
      protected
    Definition Classes
      HashUtils

21. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

24. #### def findEntry(elem: A): Option[A]

    Finds an entry in the hash table if such an element exists.

    Finds an entry in the hash table if such an element exists.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

25. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from FlatHashTable[A] to StringFormat[FlatHashTable[A]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

27. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

28. #### final def improve(hcode: Int, seed: Int): Int

    Attributes
      protected
    Definition Classes
      HashUtils

29. #### final def index(hcode: Int): Int

    Attributes
      protected

30. #### def initWithContents(c: Contents[A]): Unit

    Attributes
      protected

31. #### def initialSize: Int

    The initial size of the hash table.

32. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

33. #### def isSizeMapDefined: Boolean

    Attributes
      protected

34. #### def iterator: Iterator[A]

    Attributes
      protected

35. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

36. #### def nnSizeMapAdd(h: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

37. #### def nnSizeMapRemove(h: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

38. #### def nnSizeMapReset(tableLength: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

39. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

40. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### def randomSeed: Int

    Attributes
      protected

42. #### def removeElem(elem: A): Boolean

    Removes an elem from the hash table returning true if the element was found (and thus removed) or false if it didn't exist.

    Removes an elem from the hash table returning true if the element was found (and thus removed) or false if it didn't exist.

    Attributes
      protected

43. #### var seedvalue: Int

    Attributes
      protected

44. #### final def sizeMapBucketBitSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

45. #### final def sizeMapBucketSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

46. #### def sizeMapDisable(): Unit

    Attributes
      protected

47. #### def sizeMapInit(tableLength: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

48. #### def sizeMapInitAndRebuild(): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

49. #### var sizemap: Array[Int]

    The array keeping track of number of elements in 32 element blocks.

    The array keeping track of number of elements in 32 element blocks.

    Attributes
      protected

50. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

51. #### var table: Array[AnyRef]

    The actual hash table.

    The actual hash table.

    Attributes
      protected

52. #### var tableSize: Int

    The number of mappings contained in this hash table.

    The number of mappings contained in this hash table.

    Attributes
      protected

53. #### def tableSizeSeed: Int

    Attributes
      protected

54. #### var threshold: Int

    The next size value at which to resize (capacity * load factor).

    The next size value at which to resize (capacity * load factor).

    Attributes
      protected

55. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

56. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

59. #### def →[B](y: B): (FlatHashTable[A], B)

    Implicit information
      This member is added by an implicit conversion from FlatHashTable[A] to ArrowAssoc[FlatHashTable[A]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from HashUtils[A]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from FlatHashTable[A] to any2stringadd[FlatHashTable[A]]

### Inherited by implicit conversion StringFormat from FlatHashTable[A] to StringFormat[FlatHashTable[A]]

### Inherited by implicit conversion Ensuring from FlatHashTable[A] to Ensuring[FlatHashTable[A]]

### Inherited by implicit conversion ArrowAssoc from FlatHashTable[A] to ArrowAssoc[FlatHashTable[A]]

### Ungrouped